! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program test_detection_stats

  use detection_stats
  use errorhandling

!  call test_chi2Prob
!
!contains
!
!  subroutine test_chi2Prob
    real(single) :: chi2 = 2.706
    integer      :: idegFree = 1
    real(single) :: fdegFree = 1
    real(single) :: probability	! to receive
    integer      :: status	! to receive

    call chi2Prob(chi2, idegFree, probability, status)		! chi2ProbInteger
    if (status .ne. 0) then
      write(errstr, *) "Status = ", status
      call error("Chi2ProbIntegerStatus")
    ! else if (status .ne. 0) then
    else
      write(errstr, *) "Probability(Integer) = ", probability
      call error("Chi2ProbIntegerProb")
    end if

    call chi2ProbSingle(chi2, fdegFree, probability, status)	! chi2ProbSingle
    if (status .ne. 0) then
      write(errstr, *) "Status = ", status
      call error("Chi2ProbSingleStatus")
    else
      write(errstr, *) "Probability(Single) = ", probability
      call error("Chi2ProbSingleProb")
    end if
!  end subroutine test_chi2Prob

end program test_detection_stats
