! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program testsort

  use errorhandling
  use sort_mod

  integer :: array(0:9) = (/ 31, 41, 59, 26, 53, 58, 97, -31, -41, 0 /)
  integer :: order(10)
  integer :: x(0:9) = (/ -41,  -31,  0,  26,  31,  41,  53,  58,  59, 97 /)
  integer :: y(10) = (/ 9,  8,  10,  4,  1,  2,  5,  6,  3,  7 /)

  integer :: array1(10) = (/ 31, 41, 59, 26, 53, 58, 97, -31, -41, 0 /)
  integer :: order1(10)
  integer :: x1(10) = (/ -41,  -31,  0,  26,  31,  41,  53,  58,  59, 97 /)
  integer :: y1(10) = (/ 9,  8,  10,  4,  1,  2,  5,  6,  3,  7 /)

  integer :: j

  call quickSort(array, order)

  do j = lbound(array,1),ubound(array,1)
     if(array(j) /= x(j) .or. order(j+1) /= y(j+1)) then
        write(errstr, *) "quickSort failed", array, order
        call error("SortFailed")
     end if
  end do

  call quickSort(array1, order1)

  do j = 1,size(array1)
     if(array1(j) /= x1(j) .or. order1(j) /= y1(j)) then
        write(errstr, *) "quickSort failed", array1, order1
        call error("SortFailed")
     end if
  end do

end program testsort
